
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3 
#property indicator_color1  Blue            
#property indicator_color2  Red
#property indicator_color3  DimGray  
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  4
#property indicator_minimum 0
#property indicator_maximum 1        

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    TTMPeriod       = 6.0;
extern int    MaMode          = MODE_EMA;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double upH[];
double dnH[]; 
double nuH[];   
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,upH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,nuH); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,trend);

       //
       //
       //
       //
       //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"  TTM SW Bars("+TTMPeriod+")");
     
    
return(0);
}

int deinit()  {  return(0);  }
  
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { upH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for (i=limit; i>=0; i--)
     {    
        double Low_ma  = iMA(NULL,0,TTMPeriod,0,MaMode,PRICE_LOW,i);
        double High_ma = iMA(NULL,0,TTMPeriod,0,MaMode,PRICE_HIGH,i);
        double close   = iClose(NULL,0,i);
        double L3      = (High_ma- Low_ma) / 3 + Low_ma;
        double H3      = 2 * (High_ma- Low_ma) / 3 + Low_ma;
      
        //
        //
        //
        //
        //
      
        upH[i] = EMPTY_VALUE;
        dnH[i] = EMPTY_VALUE;
        nuH[i] = EMPTY_VALUE;   
        trend[i] = 0;   
           if (close > H3)               trend[i] = 1;
           if (close < L3)               trend[i] =-1;
           if (close < H3 && close > L3) trend[i] = 0;
           if (trend[i] == 1) upH[i] = 1;
           if (trend[i] ==-1) dnH[i] = 1;
           if (trend[i] == 0) nuH[i] = 1;
   }
   manageAlerts();
   return(0);
   }
 
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TTMPeriod,MaMode,3,y);
         upH[i]   = EMPTY_VALUE;
         dnH[i]   = EMPTY_VALUE;
         nuH[i]   = EMPTY_VALUE;
            if (trend[i] == 1) upH[i] = 1;
            if (trend[i] ==-1) dnH[i] = 1;
            if (trend[i] == 0) nuH[i] = 1;   
   }
   manageAlerts();  
return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)                          doAlert(whichBar,"up");
         if (trend[whichBar] ==-1)                          doAlert(whichBar,"down");
         if (trend[whichBar] == 0 && trend[whichBar+1]== 1) doAlert(whichBar,"no direction");
         if (trend[whichBar] == 0 && trend[whichBar+1]==-1) doAlert(whichBar,"no direction");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TTM SW Bars ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TTM SW Bars "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

